REBOL [
    Title: "Calculette parlante"
    Date: 9-sep-2005
    Version: 1.4.0
    File: %calculator.r
    Author: "J. Colineau"
    Purpose: "Talking calculator"
    ;Needs: [%mm-sdk030.r]
    library: [
        level: 'intermediate 
        platform: none 
        type: none 
        domain: [GUI math] 
        tested-under: none 
        support: none 
        license: none 
        see-also: none
    ]
    comments: {
    adaptation de calculator.r de Jeff Kreis
    v1.4.0 utilise COMLib de Anton RollsS
    }
]

ssh: system/script/header
appli: "REBOL - synthse"


mydll: load/library %rebdll.dll
window_Present: make routine! [
	ClassName [string!]
	WindowName [string!]
	return: [integer!]
] mydll "IsPresent"

;- test de prsence d'une autre instance
a: window_Present "REBOLWind" appli
if a = 1 [do-events quit]

{
digit_Launch: make routine! [
	return: [integer!]
] mydll "DigitLaunch"
digit_Present: make routine! [
	return: [integer!]
] mydll "DigitPresent"
digit_Play: make routine! [
	return: [integer!]
] mydll "DigitPlay"
digit_Stop: make routine! [
	return: [integer!]
] mydll "DigitStop"
digit_Close: make routine! [
	return: [integer!]
] mydll "DigitClose"


prononce: func [mot] [
	if digit_Present = 0 [digit_Launch wait 0:00:01]
	digit_Stop
	write clipboard:// mot
	digit_Play
	wait (length? mot) / 5  ; pour grer les attentes
	]

	
query-on-close: func [face event] [
	either equal? event/type 'close [
		digit_Close
		remove-event-func :query-on-close
		RETURN event
	] [event]
]	
}

prononce: func [str][
	; utile pour certaines synthses
	str1: copy str
	if found? find str1 "- "[replace str1 "- " "moins "]
	if found? find str1 "* "[replace str1 "* " "fois "]
	if found? find str1 "/ "[replace str1 "/ " "par "]
	
	do/args %simpleTTS/simpleTTS.r str1
]	
query-on-close: func [face event] [
	either equal? event/type 'close [
		;digit_Close
		;  crire
		remove-event-func :query-on-close
		RETURN event
	] [event]
]	

calculate: does [
	prononce text-box/text
	;wait 0.3
    if error? try [text-box/text: form do text-box/text][
        text-box/text: "Erreur"
        text-box/color: red
    ]
    auto-clear: true
    show text-box
    prononce "gale"
    ;wait 0.3
    prononce text-box/text
]

calculator: layout [   
    style btn btn 80x42 yellow font-size 28 font-color 60.60.60 bold 
    style kc btn brick [text-box/text: copy "0" auto-clear: true show text-box]
    style k= btn orange [calculate]
    style k  btn  [
        if auto-clear [clear text-box/text text-box/color: snow auto-clear: false]
        ;prononce face/text
        append text-box/text face/text
        show text-box
    ]
    origin 20
    backcolor rebolor
    space 8
    text-box: field "0" 344x48 font-size 28 bold font-color 60.60.60 snow right feel none
    pad 8
    across
    kc "C" keycode [#"C" #"c" page-down]
    k "(" #"("  k ")" #")"  k " / " #"/" return 
    k "7" #"7"  k "8" #"8"  k "9" #"9"  k " * " #"*" return 
    k "4" #"4"  k "5" #"5"  k "6" #"6"  k " - " #"-" return 
    k "1" #"1"  k "2" #"2"  k "3" #"3"  k " + " #"+" return 
    k "0" #"0"  k "-"       k "." #"."
    k= "=" keycode [#"=" #"^m"] return
    key keycode [#"^(ESC)" #"^q"] [sv-TTS/del quit]
    do [insert-event-func :query-on-close]
]

auto-clear: true

;if digit_Present = 0 [digit_Launch wait 0:00:01]

prononce "salut"

view/new center-face calculator do-events