REBOL [
    Title: "Paint MR"
    Date: 22-May-2001/17:15:51-7:00
    Version: 1.1.0
    File: %paint-MR.r
    Author: "Frank Sievertsen"
    Purpose: "The world's smallest paint program."
    Category: [util vid view 3]
    Description: {version de paint.r modifie pour M. Rose
    		gestion de l'paisseur des traits}
]

appli: "REBOL - Paint"
do %uneinstance.r

context [
    color: fill-color: start: draw-image: draw-pos: tmp: none
    color: black
    fill-color: white
    largeur: 1
    type: 'box
    undos: [] redos: []  
    draw: func [offset /local tmp tmp1] [
            ddd: ""
           either type = 'circle [
            		tmp: (offset - start)
                	tmp1: to-integer square-root add tmp/x ** 2 tmp/y ** 2
            		ddd: compose [pen (color) fill-pen (color) 
            		(type) (start) (tmp1)        	
            		]
        			]
            		[
           either type = 'line [
           			d: offset - start
           			h: square-root (d/x * d/x + (d/y * d/y))
           			normal: -1x1 * reverse ((largeur ) * d / h)
           			ddd: compose [pen (color) fill-pen (color)
           			circle (start) (largeur - 1)
           			circle (offset) (largeur - 1)
           			polygon (start + normal) (start - normal) (offset - normal) (offset + normal)]
       				]
           			[ddd: compose [pen (color) fill-pen (color)  
            		(type) (start ) (offset)]
            		]
        		]
            either type = 'circle [
            		append ddd compose [pen (color) fill-pen (fill-color) 
            		(type) (start) (tmp1 - (largeur - 1))        	
            		]
        			]
        	 [either type = 'line []
            		[append ddd compose [pen (color) fill-pen (fill-color)  
            		(type) (start + (1x1 * (largeur - 1))) (offset - (1x1 * (largeur - 1)))]
            		]
        		]
        		   
       ; probe ddd
        ddd
    ]
    draw-modele: func[][ 
    		  modele/effect/draw: compose [
            pen (color) fill-pen (fill-color)
            (type)  
            (either type = 'circle [20x20] [8x8])
            (either type = 'circle [14] [32x32])
        ]
    		show modele
	]
	sauver: func [][
		save/bmp %temp.bmp to-image draw-image 
		fichier: second request-file/path
		call/wait rejoin ["convert2jpg.exe " "temp.bmp " fichier ".jpg" ]
	]
    view/new center-face lay: layout [
        backdrop effect compose [gradient 1x1 (sky) (water)]
        across
        draw-image: image white 400x400 effect [draw []]
        feel [engage: func [face action event] [
            if all [type start] [
                if find [over away] action [
                    append clear draw-pos draw event/offset
                    show face
                ]
                if action = 'up [
                    append/only undos draw-pos
                    draw-pos: tail draw-pos
                    start: none
                ]
            ]
            if all [type action = 'down] [
                start: event/offset
            ]
        ]]
        do [draw-pos: draw-image/effect/draw]
        guide
        style text text [
            tmp: first back find face/parent-face/pane face
            tmp/feel/engage tmp 'down none
            tmp/feel/engage tmp 'up none
        ]

        label "Outil" return
        box 20x20 white effect [draw [pen black line 5x10 15x10]] [type: 'line draw-modele]
        box 20x20 white effect [draw [pen black circle 10x10 5]] [type: 'circle draw-modele]
        box 20x20 white effect [draw [pen black box 5x5 15x15]]  [type: 'box draw-modele]
        modele: box 40x40 white effect[draw 5x5]
        return
        label "Taille" return
        box 20x20 white effect [draw [pen black box 10x5 10x15]] [largeur: 1]
        box 20x20 white  effect [draw [pen black box 9x5 10x15]] [largeur: 2]
        box 20x20 white  effect [draw [pen black fill-pen black box 8x5 12x15]] [largeur: 4]
        box 20x20 white  effect [draw [pen black fill-pen black box 6x5 14x15]] [largeur: 8]
        return
        style color-box btn 20x20 [
           color:  select face/effect 'colorize ;face/color
           draw-modele
        ] 
        label "Couleur"
        return
        color-box 0.0.0
        color-box 160.160.160
        color-box 255.0.0
        color-box 0.255.0
        color-box 0.0.255
        return
        color-box 255.255.255
        color-box 210.210.210
        color-box 0.255.255
        color-box 255.0.255
        color-box 255.255.0
        return
        style color-box1 btn 20x20 [
           fill-color:  select face/effect 'colorize ;face/color
           draw-modele
        ] 
        label "Remplissage"
        return
        color-box1 
        color-box1 0.0.0
        color-box1 255.0.0
        color-box1 0.255.0
        color-box1 0.0.255
        return
        color-box1 255.255.255
        color-box1 210.210.210
        color-box1 0.255.255
        color-box1 255.0.255
        color-box1 255.255.0
        return
        style color-box2 btn 20x20 [
            draw-image/color: select face/effect 'colorize  ; face/color pour styles "normaux"
           show draw-image
        ] 
        label "couleur de fond"
        return
        color-box2 
        color-box2 0.0.0
        color-box2 255.0.0
        color-box2 0.255.0
        color-box2 0.0.255
        return
        color-box2 255.255.255
        color-box2 210.210.210
        color-box2 0.255.255
        color-box2 255.0.255
        color-box2 255.255.0
        return
        at 20x450 across
        btn 140x30 orange "Dfaire" [if not empty? undos [
            append/only redos copy last undos
            draw-pos: clear last undos
            remove back tail undos
            show draw-image
        ]]
        btn 140x30 yellow "Refaire" [if not empty? redos [
            append/only undos draw-pos
            draw-pos: insert draw-pos last redos
            remove back tail redos
            show draw-image
        ]]
       ; pad 120x0
       btn 140x30 water "Enregistrer" [sauver]
        btn 140x30 water "Quitter" [quit]
    ]

]