REBOL[
title "Puissance4"
author "Emmanuel Garbe"
comments:
    [
        Ce programme en Rebol consiste  raliser un puissance4 en mode graphique avec Rebolview.
        les objectifs sont les suivants  
            - avoir la possibilit de jouer seul contre l'ordinateur ou  2.
            - avoir un pion qui se dplace sur le haut du damier afin de dterminer la case choisie par l'utilisateur.
            - donner l'impression que le pion tombe dans une case lorsque l'utilisateur clique sur la souris pour 
            faire descendre son pion.
            - afficher le vainqueur quand 4 pions sont aligns.
            - avoir la possibilit de jouer autant de fois que l'on veut.
        
    ]
; History [23-apr-2003 "Modifs accessibili Marie-Rose: accs direct mode un joueur"]
]

initialisation: does
[
    jouer: 1;permet de dterminer le joueur qui joue
    pos: pos1: pos2: pos3: pos4: pos-souris: 300x10;dtermine la position du pion qui se dplace
    xy1: 0x0;tuple utilis pour dessiner la grille
    xy2: 100x100;tuple utilis pour dessiner la grille
    pionjaune: load %pionbleu.bmp
    pionrouge: load %pionrouge.bmp
    pioninterjaune: load %pioninterb.bmp;pion intermdiaire utilis pour donner l'impression que le pion tombe
    pioninterrouge: load %pioninterr.bmp
    pion: pionjaune;variable qui reoit la couleur du pion
    inc: 0x0;tuple qui permet de faire tomber le pion
    ligne: lignejou: 9
    puissance4: array [ 9 9 ];cration d'un tableau de 9 cases sur 9 servant  effectuer les calculs
    bool-descente: 1;dtermine si le pion doit continuer  descendre
    jeu-possible: true;dtermine si le joueur peut jouer

    ;;;cration de l'image qui va afficher le message de fin
    message-gagner: layout/size
    [
        backdrop 255.255.255
        messa: title black 155x110 ""
    ] 170x120

    msg: make image! message-gagner

    ;;;initialisation de la reprsentation du puissance4 en mmoire
    ;;;toutes les cases sont initialises  0.
    for i 1 9 1
    [
        for j 1 9 1
        [
           poke(pick puissance4 i )j 0 
        ]
    ]

    ;;;cration de l'image de la grille du puissance4
    fond: layout/size 
    [ 
        backdrop 255.255.255 
        at 0x0
        boite: box 287x325 white effect [ gradient 0x1 255.255.0 0.255.255
                                          draw [] 
                                        ] 
    ] 290x325
    ;;; code modifi pour compatibilit 1.2.41
       do
        [
            clear boite/effect/draw
            ;;;;;trac des traits verticaux
            for i 0 3 1
            [
                xy1/x: xy2/x: i
                xy1/y: 0
                xy2/y: 325
                append boite/effect/draw reduce [ 'pen blue 'line xy1 xy2 ]
            ]
            xy1/x: xy2/x: 35
            xy2/y: 325
            xy1/y: 39
            loop 8 
            [
                append boite/effect/draw reduce [ 'pen blue 'line xy1 xy2 ]
                xy2/x: xy1/x: xy1/x + 31
            ]
            xy1/y: 0
            xy2/y: 39
            xy1/x: xy2/x: 35
            ;;;trac des pointills
            loop 8
            [
                append boite/effect/draw reduce [ 'pen red 
                                                  'fill-pen none 
                                                  'line-pattern 2 2 
                                                  'line xy1 xy2 
                                                ]
                xy1/x: xy2/x: xy1/x + 31
            ]               
            xy1/y: 0
            xy2/y: 325
            for i 283 286 1
            [
                xy1/x: xy2/x: i
                append boite/effect/draw reduce [ 'pen blue 
                'line-pattern none
                'line xy1 xy2]
            ]
            ;;;trac des traits horizontaux
            for i 39 41 1
            [
                xy1/y: xy2/y: i
                xy1/x: 0
                xy2/x: 286
                append boite/effect/draw reduce [ 'pen blue 'line xy1 xy2 ]
            ]
            xy1/x: 0
            xy2/x: 286
            xy2/y: xy1/y: 72
            loop 8 
            [
                append boite/effect/draw reduce [ 'pen blue 'line xy1 xy2 ]
                xy2/y: xy1/y: xy1/y + 31
            ]
            for i 320 324 1
            [
                xy1/y: xy2/y: i
                append boite/effect/draw reduce [ 'pen blue 'line xy1 xy2 ]
            ] 
        ]

    grille: make image! fond

    choix-couleur: 1

    ;;;cration de l'cran logique 
    grille-layout: layout/size
    [
        at 0x0
        grille-buffer: image grille 290x325 effect [ draw [] ]
    ]290x325

    grille: copy make image! grille-layout

    grille-buffer/image: copy grille
    grille-buffer/effect/draw: copy []
]

;;;fonction qui sert  dterminer la couleur du pion qui sera afficher
couleur-joueur: does
[
    either choix-couleur == 2
    [
        choix-couleur: 1
        return red
    ]
    [
        choix-couleur: 2
        return blue
    ]
] 

;;;retourne la position de la coordonnes x
;;;il s'agit de la case dans laquelle le pion est jou
position-x: does
[
    switch colonnejou
    [
        1[return 19
         ]
        2[return 50
         ]
        3[return 81
         ]
        4[return 112
         ]
        5[return 143
         ]
        6[return 174
         ]
        7[return 205
         ]
        8[return 236
         ]
        9[return 267
         ]
    ]
]

;;;fonction qui permet de vrifier si 1 des joueurs a gagn la partie
gagner-puissance4: does
[
    either jouer == 81
    [
        messa/text: "Vous tes  galit"
        clear cadre/effect/draw
        msg: make image! message-gagner
        append grille-buffer/effect/draw reduce [ 'image 0x0 grille 255.255.255 
                                                  'image 50x100 msg 255.255.255
                                                ]
        grille: copy make image! grille-layout
        wait 3.0
        grille: make image! fond
        clear cadre/effect/draw
        append grille-buffer/effect/draw reduce ['image 0x0 grille 255.255.255 ]
        grille: copy make image! grille-layout
        initialisation
        mode-joueur: 1
        view/title center-face ecran "PuissanceRebol4.r"  ;debut
    ]
    [
        gagner: jeu-gagn
        if gagner == true
        [
            passe: jouer // 2
            either passe == 1
            [
                messa/text: "Le joueur 1 a gagn"
            ]
            [
                either mode-joueur == 1
                [
                    messa/text: "L'ordinateur a gagn"
                ]
                [
                    messa/text: "Le joueur 2 a gagn"
                ]
            ]
            clear cadre/effect/draw
            msg: make image! message-gagner
            append grille-buffer/effect/draw reduce [ 
                                                      'image 0x0 grille 255.255.255 
                                                      'image 50x100 msg 255.255.255
                                                      'pen black
                                                      ;'line pos1 pos2 255.255.255
                                                      ;'line pos1 pos2 255.255.255
                                                      'fill-pen 255.240.0
                                                      'circle pos1 10
                                                      'circle pos2 10
                                                      'circle pos3 10
                                                      'circle pos4 10
                                                    ]
            grille: copy make image! grille-layout
            wait 3.0
            grille: make image! fond
            clear cadre/effect/draw
            append grille-buffer/effect/draw reduce ['image 0x0 grille 255.255.255 ]
            grille: copy make image! grille-layout
            initialisation
            mode-joueur: 1
            view/title center-face ecran "PuissanceRebol4.r"; debut
        ]
    ]
]

posx: make function!  [ a ] 
[
    switch a
    [
        1[return 19
         ]
        2[return 50
         ]
        3[return 81
         ]
        4[return 112
         ]
        5[return 143
         ]
        6[return 174
         ]
        7[return 205
         ]
        8[return 236
         ]
        9[return 267
         ]
    ]
]

posy: make function! [ b ]
[
    switch b
    [
        1[return 55]
        2[return 86]
        3[return 117]
        4[return 148]
        5[return 179]
        6[return 210]
        7[return 241]
        8[return 272]
        9[return 303]
    ]
]

;;;controle au niveau de la mmoire si il y a un gagnant horizontalement
victoire-horizontale: does
[
    for i 1 9 1
    [
        for j 1 9 1
        [
            if ( j + 3 ) <= 9
            [
                pion1: pick ( pick puissance4 i ) j
                pion2: pick ( pick puissance4 i ) j + 1
                pion3: pick ( pick puissance4 i ) j + 2
                pion4: pick ( pick puissance4 i ) j + 3
                if all [ ( pion1 <> 0 )( pion1 == pion2 ) ( pion2 == pion3 ) ( pion3 == pion4 ) ]
                [
                    pos1/x: posx j
                    pos1/y: posy i
                    pos2/x: posx ( j + 1 )
                    pos2/y: posy i
                    pos3/x: posx ( j + 2 )
                    pos3/y: posy i
                    pos4/x: posx ( j + 3 )
                    pos4/y: posy i
                    return true    
                ]
            ] 
        ]
    ]
    return false
]

;;;controle au niveau de la mmoire si il y a une victoire verticale
victoire-verticale: does
[
    for i 1 9 1
    [
        for j 1 9 1
        [
            if ( i + 3 ) <= 9
            [
                pion1: pick ( pick puissance4 i ) j
                pion2: pick ( pick puissance4 i + 1 ) j
                pion3: pick ( pick puissance4 i + 2 ) j
                pion4: pick ( pick puissance4 i + 3 ) j
                if all [ ( pion1 <> 0 )( pion1 == pion2 ) ( pion2 == pion3 ) ( pion3 == pion4 ) ]
                [
                    pos1/x: posx j
                    pos1/y: posy i
                    pos2/x: posx j
                    pos2/y: posy ( i + 1 )
                    pos3/x: posx j
                    pos3/y: posy ( i + 2 )
                    pos4/x: posx j
                    pos4/y: posy ( i + 3 )
                    return true    
                ]
            ] 
        ]
    ]
    return false
]

;;;controle au niveau de la mmoire si il y a une victoire en diagonale vers la droite
victoire-diag1: does
[
    for i 1 9 1
    [
        for j 1 9 1
        [
            if all [ ( ( i + 3 ) <= 9 ) ( ( j + 3 ) <= 9 ) ]
            [
                pion1: pick ( pick puissance4 i ) j
                pion2: pick ( pick puissance4 i + 1 ) j + 1
                pion3: pick ( pick puissance4 i + 2 ) j + 2
                pion4: pick ( pick puissance4 i + 3 ) j + 3
                if all [ ( pion1 <> 0 )( pion1 == pion2 ) ( pion2 == pion3 ) ( pion3 == pion4 ) ]
                [
                    pos1/x: posx j
                    pos1/y: posy i
                    pos2/x: posx ( j + 1 )
                    pos2/y: posy ( i + 1 )
                    pos3/x: posx ( j + 2 )
                    pos3/y: posy ( i + 2 )
                    pos4/x: posx ( j + 3 )
                    pos4/y: posy ( i + 3 )
                    return true    
                ]
            ] 
        ]
    ]
    return false
]

;;;controle au niveau de la mmoire si il y a une victoire en diagonale vers la gauche
victoire-diag2: does
[
    for i 1 9 1
    [
        for j 1 9 1
        [
            if all [ ( ( i + 3 ) <= 9 ) ( ( j - 3 ) >= 1) ]
            [
                pion1: pick ( pick puissance4 i ) j
                pion2: pick ( pick puissance4 i + 1 ) j - 1
                pion3: pick ( pick puissance4 i + 2 ) j - 2
                pion4: pick ( pick puissance4 i + 3 ) j - 3
                if all [ ( pion1 <> 0 )( pion1 == pion2 ) ( pion2 == pion3 ) ( pion3 == pion4 ) ]
                [
                    pos1/x: posx j
                    pos1/y: posy i
                    pos2/x: posx ( j - 1 )
                    pos2/y: posy ( i + 1 )
                    pos3/x: posx ( j - 2 )
                    pos3/y: posy ( i + 2 )
                    pos4/x: posx ( j - 3 )
                    pos4/y: posy ( i + 3 )
                    return true    
                ]
            ] 
        ]
    ]
    return false
]

;;;fonction qui retourne vrai ou faux si 4 pions sont aligns dans le tableau
jeu-gagn: does
[
    horizontale: victoire-horizontale
    verticale: victoire-verticale
    diag1: victoire-diag1
    diag2: victoire-diag2
    either any [ ( horizontale == true ) ( verticale == true ) ( diag1 == true ) ( diag2 == true )]
    [
        return true
    ]
    [
        return false
    ]
]

;;;dtermine la ligne dans laquelle le pion va tre jou
testligne: does
[
    for lignejou 1 9 1
    [
        lignemax: pick (pick puissance4 lignejou) colonnejou
        either any [( lignemax == 1) (lignemax == 2)]
        [
            poke (pick puissance4 lignejou - 1) colonnejou choix-couleur
            return lignejou - 1
        ]
        [
            if lignejou == 9
            [
                poke (pick puissance4 lignejou ) colonnejou choix-couleur
                return 9
            ]
        ]
    ]
]

;;;dtermine les coordonnes dans lesquelles le pion va tre jou
positionpion: does
[
    position: 0x0
    position/x: position-x
    ligne: testligne
    switch ligne
    [
        1[position/y: 55
          return position]
        2[position/y: 86
          return position]
        3[position/y: 117
          return position]
        4[position/y: 148
          return position]
        5[position/y: 179
          return position]
        6[position/y: 210
          return position]
        7[position/y: 241
          return position]
        8[position/y: 272
          return position]
        9[position/y: 303
          return position]
    ]
]

;;;permet de changer de joueur
joueur-suivant: does
[
    pos: pos-souris: 170x0
    clear cadre/effect/draw
    passe: jouer // 2
    either passe == 1
    [
        pion: pionrouge
    ]
    [
        pion: pionjaune
    ]
    pos: positionpion
    append grille-buffer/effect/draw reduce [ 'pen black 
                                               coul: couleur-joueur
                                              'fill-pen coul
                                              'circle pos 10 ]
    grille: copy make image! grille-layout
    gagner-puissance4
    wait 0.2
    jeu-possible: true
    bool-descente: 1
]

;;;dtermine la descente du pion au niveau de l'affichage
test-descente-pion: does
[
    for lignejou 1 9 1
    [
        lignemax: pick (pick puissance4 lignejou) colonnejou
        if any [( lignemax == 1) (lignemax == 2)]
        [
            return lignejou - 1
        ]
    ]
    lignejou: 9
    return 9
]

;;;jusqu'o il faut descendre
jeu: does
[    
    if bool-descente == 1
    [ligneenbas: test-descente-pion
     bool-descente: 0]
    switch ligneenbas
    [
        1[either pos/y >= 41
          [return true]
          [return false]
         ]
        2[either pos/y >= 72
          [return true]
          [return false]
         ]
        3[either pos/y >= 103
          [return true]
          [return false]
         ]
        4[either pos/y >= 134
          [return true]
          [return false]
         ]
        5[either pos/y >= 165
          [return true]
          [return false]
         ]
        6[either pos/y >= 196
          [return true]
          [return false]
         ]
        7[either pos/y >= 227
          [return true]
          [return false]
         ]
        8[either pos/y >= 258
          [return true]
          [return false]
         ]
        9[either pos/y >= 289
          [return true]
          [return false]
         ]
    ]        
]

;;;fonction qui permet de faire descendre le pion
descendre: does
[
    arret-descente: jeu
    while [ arret-descente == false ]
    [
        inc/y: 3
        inc/x: 0
        pos: pos + inc
        position-intermdiaire: pos/y // 2
        passe: jouer // 2
        either position-intermdiaire == 1
        [
            either passe == 1
            [
                pion: pioninterjaune
            ]
            [
                pion: pioninterrouge
            ]
        ]   
        [
            either passe == 1
            [
                pion: pionjaune
            ]
            [
                pion: pionrouge
            ]
        ]
        cadre/effect/draw: copy reduce [ 'image 0x0 grille 255.255.255 
                                         'image pos pion 255.255.255 
                                       ]
        show cadre
        arret-descente: jeu
    ]
    joueur-suivant     
]

;;;permet de vrifier que l'on peut jouer dans la case choisie
verifie-colonne: does
[
    colonne: pick (pick puissance4 1) colonnejou
    either colonne == 0
    [
        return true
    ]
    [
        return false
    ]
]

;;;permet de vrifier que le pion est dans les cases
;;;le '+ 22' et le '- 15' sont utiliss pour centrer les pions dans les cases
dans-les-cases: does
[
    either pos-souris/x <= (34 + 22)
    [
       pos/x: 18 - 15;le - 15 sert  centrer le pion
       colonnejou: 1
    ]
    [
        either all [ ( pos-souris/x >= (35 + 22) ) ( pos-souris/x <= ( 65 + 22 ) ) ]
        [
            pos/x: 51 - 15
            colonnejou: 2
        ]
        [
            either all [ ( pos-souris/x >= (66 + 22) ) ( pos-souris/x <= (96 + 22) ) ]
            [
                pos/x:  82 - 15
                colonnejou: 3
            ]
            [
                either all [ ( pos-souris/x >= (97 + 22)) ( pos-souris/x <= (128 + 22) ) ]
                [
                    pos/x: 113 - 15
                    colonnejou: 4
                ]
                [
                    either all [ ( pos-souris/x >= (129 + 22)) ( pos-souris/x <= (159 + 22) ) ]
                    [
                        pos/x: 144 - 15
                        colonnejou: 5
                    ]
                    [
                        either all [ ( pos-souris/x >= (160 + 22)) ( pos-souris/x <= (190 + 22 )) ]
                        [
                            pos/x: 175 - 15
                            colonnejou: 6
                        ]
                        [
                            either all [ ( pos-souris/x >= (191 + 22)) ( pos-souris/x <= (221 + 22) ) ]
                            [
                                pos/x: 206 - 15
                                colonnejou: 7
                            ]
                            [
                                either all [ ( pos-souris/x >= (222 + 22)) ( pos-souris/x <= (252 + 22) ) ]
                                [
                                    pos/x: 237 - 15
                                    colonnejou: 8
                                ]
                                [
                                    if pos-souris/x > (253 + 22)
                                    [
                                        pos/x: 268 - 15
                                        colonnejou: 9
                                    ]
                                ]
                            ]
                        ]
                    ]
                ]
            ]
        ]
    ]    
]

;;;controle le dplacement du pion
bouge-pion: does
[
    dans-les-cases
    pos/y: 0
    cadre/effect/draw: copy reduce ['image 0x0 grille 255.255.255 
                                    'image pos pion 255.255.255 ]
    show cadre
]

;;;comme son nom l'indique: sert  vrifier que l'ordi peut attaquer de faon horizontale
attaque-ordi-horizontale: does
[
    for i 1 9 1
    [
        for j 1 9 1
        [
            if ( j + 3 ) <= 9
            [
                pion1: pick ( pick puissance4 i ) j
                pion2: pick ( pick puissance4 i ) j + 1
                pion3: pick ( pick puissance4 i ) j + 2
                pion4: pick ( pick puissance4 i ) j + 3
                either any [ all [ ( pion1 == 0 )( pion2 == 2 )( pion2 == pion3 )( pion2 == pion4 ) ]
                             all [ ( pion1 == 2 )( pion2 == 0 )( pion1 == pion3 )( pion1 == pion4 ) ]
                             all [ ( pion1 == 2 )( pion3 == 0 )( pion1 == pion2 )( pion1 == pion4 ) ]
                             all [ ( pion1 == 2 )( pion4 == 0 )( pion1 == pion2 )( pion1 == pion3 ) ]
                       ]
                [
                    if pion1 == 0
                    [
                        either (i + 1) <= 9;;;il faut vrifier si la case en dessous est vide
                        [
                            pion-endessous: pick ( pick puissance4 i + 1) j
                            if pion-endessous <> 0
                            [ 
                                caseordi: j
                                return true
                            ]
                        ]
                        [
                            caseordi: j
                            return true
                        ]
                    ]
                    if pion2 == 0
                    [
                        either (i + 1) <= 9
                        [
                            pion-endessous: pick ( pick puissance4 i + 1) j + 1
                            if pion-endessous <> 0
                            [
                                caseordi: j + 1
                                return true
                            ]
                        ]
                        [
                            caseordi: j + 1
                            return true
                        ]
                    ]
                    if pion3 == 0
                    [
                        either (i + 1) <= 9
                        [
                            pion-endessous: pick ( pick puissance4 i + 1) j + 2
                            if pion-endessous <> 0
                            [
                                caseordi: j + 2
                                return true
                            ]
                        ]
                        [
                            caseordi: j + 2
                            return true
                        ]
                    ]
                    if pion4 == 0
                    [
                        either (i + 1) <= 9
                        [
                            pion-endessous: pick ( pick puissance4 i + 1) j + 3
                            if pion-endessous <> 0
                            [
                                caseordi: j + 3
                                return true
                            ]
                        ]
                        [
                            caseordi: j + 3
                            return true
                        ]
                    ]
                ]
                [
                    if i == 9
                    [
                        if all [ ( pion1 == 0 )( pion2 == 1 )( pion2 == pion3 )( pion4 == 0 ) ]
                        [
                            caseordi: j + 3
                            return true
                        ]
                    ]
                ]
            ]
        ]
    ]
    return false
]

;;;comme son nom l'indique
attaque-ordi-verticale: does
[
    for i 1 9 1
    [
        for j 1 9 1
        [
            if ( i + 3 ) <= 9
            [
                pion1: pick ( pick puissance4 i ) j
                pion2: pick ( pick puissance4 i + 1 ) j
                pion3: pick ( pick puissance4 i + 2 ) j
                pion4: pick ( pick puissance4 i + 3 ) j
                if all [ ( pion1 == 0 )( pion2 == pion3 ) ( pion3 == pion4 )( pion2 == 2 ) ]
                [
                    caseordi: j
                    return true    
                ]
            ] 
        ]
    ]
    return false
]

;;;concerne les diagonales qui vont de gauche  droite
attaque-ordi-diag1: does
[
    for i 1 9 1
    [
        for j 1 9 1
        [
            if all [(( i + 3 ) <= 9) ((j + 3 ) <= 9 )]
            [
                pion1: pick ( pick puissance4 i ) j
                pion2: pick ( pick puissance4 i + 1 ) j + 1
                pion3: pick ( pick puissance4 i + 2 ) j + 2
                pion4: pick ( pick puissance4 i + 3 ) j + 3
                if any [ all [ ( pion1 == 0 )( pion2 == 2 )( pion2 == pion3 )( pion3 == pion4 ) ]
                         all [ ( pion1 == 2 )( pion2 == 0 )( pion1 == pion3 )( pion1 == pion4 ) ]
                         all [ ( pion1 == 2 )( pion3 == 0 )( pion1 == pion2 )( pion1 == pion4 ) ]
                         all [ ( pion1 == 2 )( pion4 == 0 )( pion1 == pion2 )( pion1 == pion3 ) ]
                       ]
                [
                    if pion1 == 0
                    [
                        either ( i + 1 ) <= 9
                        [
                            pion-endessous: pick ( pick puissance4 i + 1) j
                            if pion-endessous <> 0
                            [
                                caseordi: j
                                return true
                            ]
                        ]
                        [
                            caseordi: j
                            return true
                        ]
                    ]
                    if pion2 == 0
                    [
                        either ( i + 2 ) <= 9
                        [
                            pion-endessous: pick ( pick puissance4 i + 2) j + 1
                            if pion-endessous <> 0
                            [
                                caseordi: j + 1
                                return true
                            ]
                        ]
                        [
                            caseordi: j + 1
                            return true
                        ]
                    ]
                    if pion3 == 0
                    [
                        either ( i + 3 )<= 9
                        [
                            pion-endessous: pick ( pick puissance4 i + 3) j + 2
                            if pion-endessous <> 0
                            [
                                caseordi: j + 2
                                return true
                            ]
                        ]
                        [
                            caseordi: j + 2
                            return true
                        ]
                    ]
                    if pion4 == 0
                    [
                        either ( i + 4 ) <= 9
                        [
                            pion-endessous: pick ( pick puissance4 i + 4) j + 3
                            if pion-endessous <> 0
                            [
                                caseordi: j + 3
                                return true
                            ]
                        ]
                        [
                            caseordi: j + 3
                            return true
                        ]
                    ]
                ]
            ] 
        ]
    ]
    return false
]


;;;concerne les diagonales de droite  gauche
attaque-ordi-diag2: does
[
    for i 1 9 1
    [
        for j 1 9 1
        [
            if all [(( i + 3 ) <= 9) ((j - 3 ) >= 1 )]
            [
                pion1: pick ( pick puissance4 i ) j
                pion2: pick ( pick puissance4 i + 1 ) j - 1
                pion3: pick ( pick puissance4 i + 2 ) j - 2
                pion4: pick ( pick puissance4 i + 3 ) j - 3
                if any [ all [ ( pion1 == 0 )( pion2 == 2 )( pion2 == pion3 )( pion3 == pion4 ) ]
                         all [ ( pion1 == 2 )( pion2 == 0 )( pion1 == pion3 )( pion1 == pion4 ) ]
                         all [ ( pion1 == 2 )( pion3 == 0 )( pion1 == pion2 )( pion1 == pion4 ) ]
                         all [ ( pion1 == 2 )( pion4 == 0 )( pion1 == pion2 )( pion1 == pion3 ) ]
                       ]
                [
                    if pion1 == 0
                    [
                        either ( i + 1 ) <= 9
                        [
                            pion-endessous: pick ( pick puissance4 i + 1) j
                            if pion-endessous <> 0
                            [
                                caseordi: j
                                return true
                            ]
                        ]
                        [
                            caseordi: j
                            return true
                        ]
                    ]
                    if pion2 == 0
                    [
                        either ( i + 2 ) <= 9
                        [
                            pion-endessous: pick ( pick puissance4 i + 2) j - 1
                            if pion-endessous <> 0
                            [
                                caseordi: j - 1
                                return true
                            ]
                        ]
                        [
                            caseordi: j - 1
                            return true
                        ]
                    ]
                    if pion3 == 0
                    [
                        either ( i + 3 )<= 9
                        [
                            pion-endessous: pick ( pick puissance4 i + 3) j - 2
                            if pion-endessous <> 0
                            [
                                caseordi: j - 2
                                return true
                            ]
                        ]
                        [
                            caseordi: j - 2
                            return true
                        ]
                    ]
                    if pion4 == 0
                    [
                        either ( i + 4 ) <= 9
                        [
                            pion-endessous: pick ( pick puissance4 i + 4) j - 3
                            if pion-endessous <> 0
                            [
                                caseordi: j - 3
                                return true
                            ]
                        ]
                        [
                            caseordi: j - 3
                            print "attaq diag2 pion4"
                            return true
                        ]
                    ]
                ]
            ] 
        ]
    ]
    return false
]

;;;fait appel aux diffrentes fonctions qui permettent  l'ordinateur d'attaquer pour gagner.
ordi-attaque: does
[
    either any [ ( attaque-ordi-verticale == true ) ( attaque-ordi-horizontale == true )
                 ( attaque-ordi-diag1 == true ) ( attaque-ordi-diag2 == true ) ]
    [
        return true
    ]
    [
        return false
    ]
]

;;;comme son nom l'indique
dfense-ordi-horizontale: does
[
    for i 1 9 1
    [
        for j 1 9 1
        [
            if ( j + 3 ) <= 9
            [
                pion1: pick ( pick puissance4 i ) j
                pion2: pick ( pick puissance4 i ) j + 1
                pion3: pick ( pick puissance4 i ) j + 2
                pion4: pick ( pick puissance4 i ) j + 3
                either any [ all [ ( pion1 == 0 )( pion2 == 1 )( pion2 == pion3 )( pion2 == pion4 ) ]
                             all [ ( pion1 == 1 )( pion2 == 0 )( pion1 == pion3 )( pion1 == pion4 ) ]
                             all [ ( pion1 == 1 )( pion3 == 0 )( pion1 == pion2 )( pion1 == pion4 ) ]
                             all [ ( pion1 == 1 )( pion4 == 0 )( pion1 == pion2 )( pion1 == pion3 ) ]
                       ]
                [
                    if pion1 == 0
                    [
                        either (i + 1) <= 9;;;il faut vrifier si la case en dessous est vide
                        [
                            pion-endessous: pick ( pick puissance4 i + 1) j
                            if pion-endessous <> 0
                            [ 
                                caseordi: j
                                return true
                            ]
                        ]
                        [
                            caseordi: j
                            return true
                        ]
                    ]
                    if pion2 == 0
                    [
                        either (i + 1) <= 9
                        [
                            pion-endessous: pick ( pick puissance4 i + 1) j + 1
                            if pion-endessous <> 0
                            [
                                caseordi: j + 1
                                return true
                            ]
                        ]
                        [
                            caseordi: j + 1
                            return true
                        ]
                    ]
                    if pion3 == 0
                    [
                        either (i + 1) <= 9
                        [
                            pion-endessous: pick ( pick puissance4 i + 1) j + 2
                            if pion-endessous <> 0
                            [
                                caseordi: j + 2
                                return true
                            ]
                        ]
                        [
                            caseordi: j + 2
                            return true
                        ]
                    ]
                    if pion4 == 0
                    [
                        either (i + 1) <= 9
                        [
                            pion-endessous: pick ( pick puissance4 i + 1) j + 3
                            if pion-endessous <> 0
                            [
                                caseordi: j + 3
                                return true
                            ]
                        ]
                        [
                            caseordi: j + 3
                            return true
                        ]
                    ]
                ]
                [
                    if i == 9
                    [
                        if all [ ( pion1 == 0 )( pion2 == 1 )( pion2 == pion3 )( pion4 == 0 ) ]
                        [
                            caseordi: j + 3
                            return true
                        ]
                    ]
                ]
            ]
        ]
    ]
    return false
]

;;;comme son nom l'indique
dfense-ordi-verticale: does
[
    for i 1 9 1
    [
        for j 1 9 1
        [
            if ( i + 3 ) <= 9
            [
                pion1: pick ( pick puissance4 i ) j
                pion2: pick ( pick puissance4 i + 1 ) j
                pion3: pick ( pick puissance4 i + 2 ) j
                pion4: pick ( pick puissance4 i + 3 ) j
                if all [ ( pion1 == 0 )( pion2 == 1 )( pion2 == pion3 ) ( pion3 == pion4 ) ]
                [
                    caseordi: j
                    return true    
                ]
            ] 
        ]
    ]
    return false
]

;;;diagonale de gauche  droite
dfense-ordi-diag1: does
[
    for i 1 9 1
    [
        for j 1 9 1
        [
            if all [(( i + 3 ) <= 9) ((j + 3 ) <= 9 )]
            [
                pion1: pick ( pick puissance4 i ) j
                pion2: pick ( pick puissance4 i + 1 ) j + 1
                pion3: pick ( pick puissance4 i + 2 ) j + 2
                pion4: pick ( pick puissance4 i + 3 ) j + 3
                if any [ all [ ( pion1 == 0 )( pion2 == 1 )( pion2 == pion3 )( pion3 == pion4 ) ]
                         all [ ( pion1 == 1 )( pion2 == 0 )( pion1 == pion3 )( pion1 == pion4 ) ]
                         all [ ( pion1 == 1 )( pion3 == 0 )( pion1 == pion2 )( pion1 == pion4 ) ]
                         all [ ( pion1 == 1 )( pion4 == 0 )( pion1 == pion2 )( pion1 == pion3 ) ]
                       ]
                [
                    if pion1 == 0
                    [
                        either ( i + 1 ) <= 9
                        [
                            pion-endessous: pick ( pick puissance4 i + 1) j
                            if pion-endessous <> 0
                            [
                                caseordi: j
                                return true
                            ]
                        ]
                        [
                            caseordi: j
                            return true
                        ]
                    ]
                    if pion2 == 0
                    [
                        either ( i + 2 ) <= 9
                        [
                            pion-endessous: pick ( pick puissance4 i + 2) j + 1
                            if pion-endessous <> 0
                            [
                                caseordi: j + 1
                                return true
                            ]
                        ]
                        [
                            caseordi: j + 1
                            return true
                        ]
                    ]
                    if pion3 == 0
                    [
                        either ( i + 3 )<= 9
                        [
                            pion-endessous: pick ( pick puissance4 i + 3) j + 2
                            if pion-endessous <> 0
                            [
                                caseordi: j + 2
                                return true
                            ]
                        ]
                        [
                            caseordi: j + 2
                            return true
                        ]
                    ]
                    if pion4 == 0
                    [
                        either ( i + 4 ) <= 9
                        [
                            pion-endessous: pick ( pick puissance4 i + 4) j + 3
                            if pion-endessous <> 0
                            [
                                caseordi: j + 3
                                return true
                            ]
                        ]
                        [
                            caseordi: j + 3
                            return true
                        ]
                    ]
                ]
            ] 
        ]
    ]
    return false
]

;;;diagonale de droite  gauche
dfense-ordi-diag2: does
[
    ;print "def giag pion1"
    for i 1 9 1
    [
        for j 1 9 1
        [
            if all [ ((i + 3)  <= 9 ) (( j - 3 ) >= 1 ) ]
            [
                pion1: pick ( pick puissance4 i ) j
                pion2: pick ( pick puissance4 i + 1 ) j - 1
                pion3: pick ( pick puissance4 i + 2 ) j - 2
                pion4: pick ( pick puissance4 i + 3 ) j - 3
                if any [ all [ ( pion1 == 0 )( pion2 == 1 )( pion2 == pion3 )( pion2 == pion4 ) ]
                         all [ ( pion1 == 1 )( pion2 == 0 )( pion1 == pion3 )( pion1 == pion4 ) ]
                         all [ ( pion1 == 1 )( pion3 == 0 )( pion1 == pion2 )( pion1 == pion4 ) ]
                         all [ ( pion1 == 1 )( pion4 == 0 )( pion1 == pion2 )( pion1 == pion3 ) ]
                       ]
                [
                    if pion1 == 0
                    [
                        either ( i + 1 ) <= 9
                        [
                            pion-endessous: pick ( pick puissance4 i + 1) j
                            if pion-endessous <> 0
                            [
                                caseordi: j
                                return true
                            ]
                        ]
                        [
                            caseordi: j
                            return true
                        ]
                    ]
                    if pion2 == 0
                    [
                        either ( i + 2 ) <= 9
                        [
                            pion-endessous: pick ( pick puissance4 i + 2) j - 1
                            if pion-endessous <> 0
                            [
                                caseordi: j - 1
                                return true
                            ]
                        ]
                        [
                            caseordi: j - 1
                            return true
                        ]
                    ]
                    if pion3 == 0
                    [
                        either ( i + 3 )<= 9
                        [
                            pion-endessous: pick ( pick puissance4 i + 3) j - 2
                            if pion-endessous <> 0
                            [
                                caseordi: j - 2
                                return true
                            ]
                        ]
                        [
                            caseordi: j - 2
                            return true
                        ]
                    ]
                    if pion4 == 0
                    [
                        either ( i + 4 ) <= 9
                        [
                            pion-endessous: pick ( pick puissance4 i + 4) j - 3
                            if pion-endessous <> 0
                            [
                                caseordi: j - 3
                                return true
                            ]
                        ]
                        [
                            caseordi: j - 3
                            return true
                        ]
                    ]
                ]
            ] 
        ]
    ]
    return false
]

;;;test si l'ordinateur doit se dfendre pour empcher le joueur de gagner
ordi-dfend: does
[
    either any [ ( dfense-ordi-verticale == true ) ( dfense-ordi-horizontale == true ) 
                 ( dfense-ordi-diag1 == true ) ( dfense-ordi-diag2 == true )
               ]
    [
        return true
    ]
    [
        return false
    ]
]

;;;la distinction entre l'attaque et la dfense est utilise
;;;afin de permettre  l'ordinateur de gagner s'il en a la possibilit.
;;;si l'on fait les 2 en mme temps, le calcul ordi s'arrte quand il a
;;;trouv une solution
joue-ordi: does
[
    ;;;on vrifie si l'ordinateur peut attaquer et/ou gagner
    either ordi-attaque == true
    [
        return caseordi
    ]
    ;;;on vrifie ensuite si l'ordinateur doit se dfendre afin d'empcher le joueur de gagner
    [
        if ordi-dfend == true
        [return caseordi]
    ]
    ;;;enfin si aucun cas ne se prsente, on renvoit une valeur alatoire.
    a: random 3
    ordi-alatoire: a // 3
    either ordi-alatoire == 0
    [
        return ( colonnejou + 1 )
    ]
    [
        either ordi-alatoire == 1
        [
            return ( colonnejou - 1 )
        ]
        [
            return ( colonnejou )
        ]
    ]
]

;;;cran constitue le layout de jeu
ecran: layout/size
[
    backdrop black
    cadre: box 290x325 rate 00:00:00.01 feel;;;utilisation d'un timer pour le dplacement du pion en haut de l'cran
    [   
        engage: func [ f a e ]
        [    
            if a = 'time [ bouge-pion ]
        ]
        detect: func [ face event ];;;permet de dtecter les vnements gnrs par le joueur
        [
            either mode-joueur == 2;;;mode 2 joueurs
            [
                switch event/type
                [
                    move [ pos-souris: event/offset ]
                    down
                    [
                        colonne-vrifi: verifie-colonne;;;empche de jouer si toutes les cases d'un colonne sont remplies
                        if colonne-vrifi == true
                        [
                            if jeu-possible == true;; vite le double clic de l'utilisateur qui lance automatiquement un autre pion
                            [
                                jeu-possible: false
                                descendre
                                jouer: jouer + 1;;;sert  alterner les joueurs
                            ]
                        ]                    
                    ]
                ]
            ]
            [;;;mode 1 joueur
                passe: jouer // 2
                either passe == 1
                [
                    switch event/type
                    [
                        move [ pos-souris: event/offset ]
                        down
                        [
                            colonne-vrifi: verifie-colonne
                            if colonne-vrifi == true
                            [
                                if jeu-possible == true
                                [
                                    jeu-possible: false
                                    descendre
                                    jouer: jouer + 1
                                ]
                            ]                    
                        ]
                    ]
                ]
                [
                    colonnejou: joue-ordi;;;dtermine la case joue par l'ordi
                    colonne-vrifi: verifie-colonne
                    if colonne-vrifi == true
                    [
                        if jeu-possible == true
                        [
                            pos/x: position-x - 15
                            jeu-possible: false
                            descendre
                            jouer: jouer + 1
                        ]
                    ]
                ]
            ]
        ]
    ] effect [ draw [] ]
] 325x360

;;;dtermine l'cran de prsentation  afficher en fonction du choix de l'utilisateur
prsentation: does
[
    either mode-joueur == 1
    [
        view/title center-face prsentation-1joueur "Mode 1 joueur"
    ]
    [
        view/title center-face prsentation-2joueur "Mode 2 joueurs"
    ]
    wait 2.0
    view/title center-face ecran "PuissanceRebol4.r"
]

;;;cran de prsentation pour le mode 1 joueur
prsentation-1joueur: layout/size
[
    backdrop white effect [ gradient 0x0 0.255.255 255.255.0 ]
    at 60x50
    title "MODE 1 JOUEUR" 120.120.120
    at 60x110
    text "Le joueur 1 joue avec les pions bleus." blue
    at 150x150
    box 30x30 white effect [ gradient 0x0 0.255.255 255.255.0
                             draw [ 'pen black 
                                    'fill-pen blue
                                    'circle 15x15 10 ] 
                           ]
    at 60x190
    text "L'ordinateur joue avec les pions rouges. " red
    at 150x230
    box 30x30 white effect [ gradient 0x0 0.255.255 255.255.0
                             draw [ 'pen black
                                    'fill-pen red
                                    'circle 15x15 10 ]
                           ]
]325x360

;;;cran de prsentation pour le mode 2 joueurs
prsentation-2joueur: layout/size
[
    backdrop white effect [ gradient 0x0 0.255.255 255.255.0 ]
    at 60x50
    title "MODE 2 JOUEUR" 120.120.120
    at 60x110
    text "Le joueur 1 joue avec les pions bleus." blue
    at 150x150
    box 30x30 white effect [ gradient 0x0 0.255.255 255.255.0
                             draw [ 'pen black 
                                    'fill-pen blue
                                    'circle 15x15 10 ] 
                           ]
    at 60x190
    text "Le joueur 2 joue avec les pions rouges. " red
    at 150x230
    box 30x30 white effect [ gradient 0x0 0.255.255 255.255.0
                                draw [
                                        'pen black
                                        'fill-pen red
                                        'circle 15x15 10
                                     ]
                           ]
]325x360

;;;cran de dbut

debut: layout/size
[
    backdrop white effect [ gradient 1x0 255.0.255 0.255.0 ]
    at 30x30
    title "PUISSANCE REBOL 4"
    at 90x60
    text "Auteur : Emmanuel Garbe"
    at 100x100
    title "version1.0"
    at 90x180
    button "1 joueur" 150x50 [ initialisation
                               mode-joueur: 1;initialisation
                               prsentation ]
    button "2 joueur" 150x50 [ initialisation
                               mode-joueur: 2
                               prsentation ]
    button "Quitter" 150x50 [ quit ]
    
]325x360


;view/new/title center-face debut "Puissance4"

initialisation
mode-joueur: 1
view/new/title center-face ecran "Puissance4.r"
do-events