REBOL
[Title: "Lanceur"
	Author: " Jo "
	Version: 1.3.0
	Date: 12-Apr-2003
	comment:
	{programme lanceur
	fichiers, commentaires et images sont regroups dans lanceur.txt
	format du fichier:
	%fichierImage [do %fichierALancer] "label"
	v1.1.0 changement de format fichier lanceur.txt
	v1.2.0 filtrage des doubles clicks
	v1.3.0 adaptation  R2.7.6
	}
]

appli: "REBOL - Lanceur"

mydll: load/library %rebdll.dll
window_Present: make routine! [
	ClassName [string!]
	WindowName [string!]
	return: [integer!]
] mydll "IsPresent"


;- test de prsence d'une autre instance
a: window_Present "REBOLWind" appli
if a = 1 [do-events quit]

tableau: load %lanceur.txt
base-dir: what-dir
lancer: func[file][
	do rejoin[ base-dir file]]
	
quitterWindows: ["c:\windows\system32\rundll32.exe user,ExitWindows"]

double-clk: func [f a e][
	{action en cas de double click seulement}
		if a = 'down [
			if e/double-click [do-face f f none]
			]
		]
		
simple-clk: func [f a e][
	{action en cas de simple click seulement}
		if a = 'down [
			either e/double-click [][do-face f f none]
			]
		]
			
old-time: now/time	
time-constant: 2.0
timer-clk: func [f a e][
	{action si la dernire a eu lieu il y a plus de time-constant secondes}
		if a = 'down [
			if (to-decimal (now/time - old-time)) > time-constant [old-time: now/time do-face f f none]
			]
		]

timed-styles: stylize[
	timed-btn: btn orange feel [engage: :timer-clk]
	double-clk-btn: btn red feel [engage: :double-clk]
	simple-clk-btn: btn yellow feel [engage: :simple-clk]
]

styles_lanceur: stylize [
	vignette: image 80x80 edge [size: 2x2 color: black effect: 'ibevel]
	feel [
		over: func [face act pos] [
			face/effect: either act [reduce ['invert 'fit]] ['fit]
			show face]
		engage: :timer-clk
	]

	montag: h3
]


fenetre: copy [
	backdrop effect [gradient 0x1 80.108.142 192.192.192] ;water silver]
	styles styles_lanceur]

i: 0
forskip tableau 3 [
	if i > 3 [i: 0 append fenetre [return
			box 2x440 maroon
			return]]
	i: i + 1
	append fenetre reduce ['vignette first tableau second tableau 'montag third tableau]
]

fenetre: layout fenetre
view  fenetre

