Rebol [
	Title: "synthse"
	Date: 11-May-2004
	Version: 1.4.0
	File: %synthese.r
	Author: "Jo"
	Purpose: "Synthse vocale de texte"
	Comments: "Utilise digit"
	Help: "pas d'aide disponible"
	{
	v1.4.0 utilise COMLib de Anton Rolls
	}
]
ssh: system/script/header
appli: "REBOL - synthse"
;do %jutils1.r

mydll: load/library %rebdll.dll
window_Present: make routine! [
	ClassName [string!]
	WindowName [string!]
	return: [integer!]
] mydll "IsPresent"

;- test de prsence d'une autre instance
a: window_Present "REBOLWind" appli
if a = 1 [do-events quit]

{
digit_Launch: make routine! [
	return: [integer!]
] mydll "DigitLaunch"
digit_Present: make routine! [
	return: [integer!]
] mydll "DigitPresent"
digit_Play: make routine! [
	return: [integer!]
] mydll "DigitPlay"
digit_Stop: make routine! [
	return: [integer!]
] mydll "DigitStop"
digit_Close: make routine! [
	return: [integer!]
] mydll "DigitClose"


prononce: func [mot] [
	if digit_Present = 0 [digit_Launch wait 0:00:01]
	digit_Stop
	write clipboard:// mot
	digit_Play]

query-on-close: func [face event] [
	either equal? event/type 'close [
		digit_Close
		remove-event-func :query-on-close
		RETURN event
	] [event]
]
}
aPropos: does [
	aid: layout [
		style txt h3 center 100
		style mvh1 vh1 orange center 100
		backdrop 255.230.180
		mvh1 ssh/title
		txt ssh/author
		txt to-string ssh/date
		across
		pad 10
		btn 80x24 orange " ok " [unview aid]] view/new center-face aid]

prononce: func [str][
	do/args %simpleTTS/simpleTTS.r str
]	
query-on-close: func [face event] [
	either equal? event/type 'close [
		;digit_Close
		;  crire
		remove-event-func :query-on-close
		RETURN event
	] [event]
]	

heure: func [/local theure texte] [
	panels/pane: panel2
	theure: now/time
	texte: copy ""
	texte: rejoin ["il est " first theure " heures " second theure " !"]
	mon-message/text: copy texte show mon-message show panels
	prononce texte
	wait 0:00:03	
	panels/pane: panel1 show panels
]

date: func [/local texte jour mois indice_jour indice_mois] [
	jour: ["lundi" "mardi" "mercredi" "jeudi" "vendredi" "samedi" "dimanche"]
	mois: ["janvier" "fvrier" "mars" "avril" "mai" "juin" "juillet" "aout" "septembre" "octobre" "novembre" "dcembre"]
	indice_jour: now/weekday
	indice_mois: now/month
	panels/pane: panel2
	texte: copy ""
	texte: rejoin ["nous sommes le " jour/:indice_jour " " now/day " " mois/:indice_mois " !"]
	mon-message/text: copy texte show mon-message show panels
	prononce texte
	wait 0:00:03	
	panels/pane: panel1 show panels
]

;if digit_Present = 0 [digit_Launch wait 0:00:01]
screensize: 640x480
old-texte: copy "" ;conserve anciennes valeurs

st-syn: stylize [
	btn-img: image 80x76 effect [fit] edge [size: 2x2 color: black effect: 'ibevel]
	feel [
		engage: func [face act pos] [
			face/effect: either (act = 'down) [reduce ['emboss 'fit]] [reduce ['fit]]
			if act = 'down [do-face face face none]
			show face]
	]
	montxt: area 10.10.10 black wrap font-size 48 font-color yellow effect [grid 1000x16 gray]
]

win-msg: layout [
	style txt-msg area 10.10.10 black wrap font-size 48 font-color yellow effect [grid 1000x16 gray]
	mon-message: txt-msg 400x200
]

panel-size: screensize - 80x24 

main: layout [
	size screensize
	origin 0x0 space 0x0
	backdrop gray
	style btn btn 100x20 yellow	
	styles st-syn
	across
	image logo.gif box 440x24 effect [merge gradmul 1x0 0.0.0 128.128.128] return
	below
	btn-img %./images/visage2.gif [if (not empty? montexte/text) [old-texte: copy montexte/text prononce montexte/text focus montexte]]
	btn-img %./images/gomme.gif  [montexte/text: copy old-texte show montexte  focus montexte]
	btn-img %./images/x.gif [unfocus montexte clear montexte/text show montexte focus montexte]
	bh1: btn-img %./images/reveil.gif [heure]
	bd1: btn-img %./images/calendrier.gif [date]
	btn-img %./images/maison.gif  [unview main]
	at 82x0
	below
	ttr: vh2 440x24 rejoin [ssh/title "   v " ssh/version] center [aPropos]
	panels: box panel-size
	do [insert-event-func :query-on-close]
]

panel1: layout [size panel-size
	styles st-syn
	origin 0x0 space 0x0
	montexte: montxt panel-size "Bonjour !"
]
panel2: layout [size panel-size
	styles st-syn
	origin 0x0 space 0x0
	mon-message: montxt panel-size 
]
panel1/offset: 0x0
panel2/offset: 0x0
panels/pane: panel1

focus montexte

view/new center-face main

prononce "Bonjour !"
do-events
